# Aliaksei Vishneuski 255025
# Lab 10

# informowac uzytkownika czy ma nadpisac czy zrezygnowac analogicznie usuniecie

import string
import re

def prettify_output(func):
    def wrapper(*args, **kwargs):
        exercise_number = func.__name__.split("_")[-1]
        print("=" * 10 + '\n' * 2)
        print(f"Zadanie {exercise_number}:")
        func()
        print()
        print("=" * 20 + '\n' * 2)
    return wrapper


@prettify_output
def handle_exercise_1() -> None:
    """
    Zad1.
    Wprowadź poniższy słownik do programu. Program ma działać jak następuje:
    - wyświetla wszystkie klucze na konsoli (tzn. nazwy wszystkich albumów),
    - pobiera od użytkownika łańcuch i sprawdza czy odpowiada on kluczowi ze słownika. Jeśli tak, to
    wyświetlany jest komunikat:
    "Wykonawca albumu "Achtung baby" jest U2".
    W przeciwnym razie wyświetlana jest komunikat: "brak danych".
    {'The Sensual World':'Kate Bush', 'Shaday':'Ofra Haza', 'Achtung Baby':'U2',
    'Aion':'Dead Can Dance', 'Invisible Touch':'Genesis'}
    """
    album_artists: dict[str, str] = {
        "The Sensual World": "Kate Bush",
        "Shaday": "Ofra Haza",
        "Achtung Baby": "U2",
        "Aion": "Dead Can Dance",
        "Invisible Touch": "Genesis"
    }
    print("Dostępne albumy:")
    for album in album_artists.keys():
        print(album)
    user_input: str = input("Podaj nazwę albumu: ")
    if user_input in album_artists:
        print(f'Wykonawca albumu "{user_input}" jest {album_artists[user_input]}')
    else:
        print("brak danych")


@prettify_output
def handle_exercise_2() -> None:
    """
    Zad2.
    Zmodyfikuj kod z zad1 tak, aby możliwe było dodawanie i usuwanie przez użytkownika informacji
    o nowych albumach do słownika. Program ma zawierać proste menu
    """
    album_artists: dict[str, str] = {
        "The Sensual World": "Kate Bush",
        "Shaday": "Ofra Haza",
        "Achtung Baby": "U2",
        "Aion": "Dead Can Dance",
        "Invisible Touch": "Genesis"
    }

    while True:
        print("\nMenu:")
        print("1. Wyświetl wszystkie albumy")
        print("2. Dodaj nowy album")
        print("3. Usuń album")
        print("4. Sprawdź wykonawcę albumu")
        print("5. Wyjście")
        choice: str = input("Wybierz opcję: ")

        if choice == "1":
            print("Lista albumów:")
            for album in album_artists.keys():
                print(album)
        elif choice == "2":
            album: str = input("Podaj nazwę albumu: ")
            if album in album_artists:
                print("Album już istnieje.")
            else:
                artist: str = input("Podaj nazwę wykonawcy: ")
                album_artists[album] = artist
                print(f'Dodano album "{album}" z wykonawcą {artist}')
        elif choice == "3":
            album: str = input("Podaj nazwę albumu do usunięcia: ")
            if album in album_artists:
                del album_artists[album]
                print(f'Usunięto album "{album}"')
            else:
                print("Album nie istnieje.")
        elif choice == "4":
            album: str = input("Podaj nazwę albumu: ")
            if album in album_artists:
                print(f'Wykonawca albumu "{album}" jest {album_artists[album]}')
            else:
                print("brak danych")
        elif choice == "5":
            print("Zakończenie programu.")
            break
        else:
            print("Nieprawidłowa opcja. Spróbuj ponownie.")


@prettify_output
def handle_exercise_3() -> None:
    """
    Zad3.
    Zapisz wszystkie wyrazy z poniższego tekstu (E.A.Poe "The Raven"-fragm.) do słownika (jako
    klucze). Wartości przypisane do tych kluczy mają być równe ilości wystąpień słowa w tekscie.
    "Once upon a midnight dreary, while I pondered, weak and weary, Over many a quaint and curious
    volume of forgotten lore, While I nodded, nearly napping, suddenly there came a tapping, As of
    some one gently rapping, rapping at my chamber door. Tis some visitor, I muttered, tapping at my
    chamber door- Only this, and nothing more."
    """
    text: str = (
        "Once upon a midnight dreary, while I pondered, weak and weary, "
        "Over many a quaint and curious volume of forgotten lore, "
        "While I nodded, nearly napping, suddenly there came a tapping, "
        "As of some one gently rapping, rapping at my chamber door. "
        "Tis some visitor, I muttered, tapping at my chamber door- Only this, and nothing more."
    )

    translator = str.maketrans("", "", string.punctuation)
    clean_text: str = text.translate(translator).lower()

    words: list[str] = clean_text.split()

    word_counts: dict[str, int] = {}
    for word in words:
        if word in word_counts:
            word_counts[word] += 1
        else:
            word_counts[word] = 1

    print("Wystąpienia wyrazów:")
    for word, count in word_counts.items():
        print(f'"{word}" występuje {count} razy.')


@prettify_output
def handle_exercise_4() -> None:
    """
    Zad4.
    Przekształć poniższy tekst dopisując w nawiasach do polskich nazw ptaków ich łacińskie
    odpwiedniki. Skorzystaj w tym celu ze słownika zawierającego następujące elementy:
    {'kos':'Turdus merula', 'wilga':'Oriolus oriolus', 'rudzik':'Erithacus rubecula', 'kukulka':'Cuculus
    canorus',
    'pleszka':'Phoenicurus phoenicurus', 'bogatka':'Parus major', 'drozd':'Turdus philomelos',
    'zieba':'Fringilla coelebs',
    'dzwoniec':'Chloris chloris', 'szczygiel':'Carduelis carduelis', 'szpak':'Sturnus vulgaris',
    'kopciuszek':'Phoenicurus ochruros'}
    W polowie maja, juz przed wschodem slonca, o trzeciej zaczyna spiewac drozd, po nim rudzik, a
    chwile pozniej kos. Pol godziny pozniej odzywa sie kukulka. Zaraz po niej budzi sie bogatka. Wraz
    ze wschodem slonca, o czwartej godzinie, swoj koncert rozpoczynaja pleszka i zieba. Dwadziescia
    minut pozniej i wilga akcentuje swoja obecnosc wysoko w koronach drzew. Jeszcze pozniej swoje
    trzy grosze dodaje szpak, a tuz po nim kopciuszek. Najwiekszymi spiochami w tej ferajnie okazuja
    sie byc dzwoniec i szczygiel.
    """
    bird_dict: dict[str, str] = {
        "kos": "Turdus merula",
        "wilga": "Oriolus oriolus",
        "rudzik": "Erithacus rubecula",
        "kukulka": "Cuculus canorus",
        "pleszka": "Phoenicurus phoenicurus",
        "bogatka": "Parus major",
        "drozd": "Turdus philomelos",
        "zieba": "Fringilla coelebs",
        "dzwoniec": "Chloris chloris",
        "szczygiel": "Carduelis carduelis",
        "szpak": "Sturnus vulgaris",
        "kopciuszek": "Phoenicurus ochruros"
    }

    text: str = (
        "W polowie maja, juz przed wschodem slonca, o trzeciej zaczyna spiewac drozd, "
        "po nim rudzik, a chwile pozniej kos. Pol godziny pozniej odzywa sie kukulka. "
        "Zaraz po niej budzi sie bogatka. Wraz ze wschodem slonca, o czwartej godzinie, "
        "swoj koncert rozpoczynaja pleszka i zieba. Dwadziescia minut pozniej i wilga akcentuje "
        "swoja obecnosc wysoko w koronach drzew. Jeszcze pozniej swoje trzy grosze dodaje szpak, "
        "a tuz po nim kopciuszek. Najwiekszymi spiochami w tej ferajnie okazuja sie byc dzwoniec "
        "i szczygiel."
    )

    def replace_bird(match: re.Match) -> str:
        bird: str = match.group(0)
        latin: str = bird_dict[bird.lower()]
        return f'{bird} ({latin})'

    pattern: re.Pattern = re.compile(
        r"\b(" + "|".join(map(re.escape, bird_dict.keys())) + r")\b",
        flags=re.IGNORECASE
    )

    modified_text: str = pattern.sub(replace_bird, text)

    print("Zmodyfikowany tekst:")
    print(modified_text)


@prettify_output
def handle_exercise_5() -> None:
    """
    Zad5.
    Zapisz poniższe dane do pliku tekstowego (o nazwie dane.txt):
    bluszcz pospolity - Hedera helix
    parzydlo lesne - Aruncus dioicus
    lilak pospolity - Syringa vulgaris
    buk pospolity - Fagus sylvatica
    bez czarny - Sambucus nigra
    kalina koralowa - Viburnum opulus
    czeremcha zwyczajna - Padus avium Mill.
    azalia pontyjska - Rhododendron luteum
    lawenda lekarska - Lavandula angustifolia
    Utwórz program, który odczyta powyższe dane z pliku i utworzy z nich słownik. Finalnie zawartość
    słownika powinna zostać wyświetlona na ekranie element po elemencie
    """
    data: str = (
        "bluszcz pospolity - Hedera helix\n"
        "parzydlo lesne - Aruncus dioicus\n"
        "lilak pospolity - Syringa vulgaris\n"
        "buk pospolity - Fagus sylvatica\n"
        "bez czarny - Sambucus nigra\n"
        "kalina koralowa - Viburnum opulus\n"
        "czeremcha zwyczajna - Padus avium Mill.\n"
        "azalia pontyjska - Rhododendron luteum\n"
        "lawenda lekarska - Lavandula angustifolia"
    )

    filename: str = "dane.txt"
    with open(filename, "w", encoding="utf-8") as file:
        file.write(data)

    plant_dict: dict[str, str] = {}
    with open(filename, "r", encoding="utf-8") as file:
        for line in file:
            line: str = line.strip()
            if line:
                try:
                    key, value = line.split(" - ", maxsplit=1)
                    plant_dict[key.strip()] = value.strip()
                except ValueError:
                    continue  # Pomija linie, które nie spełniają formatu

    print("Zawartość słownika:")
    for plant, latin in plant_dict.items():
        print(f'Klucz: "{plant}", Wartość: "{latin}"')


def main() -> None:
    usecases = {
        "1": handle_exercise_1,
        "2": handle_exercise_2,
        "3": handle_exercise_3,
        "4": handle_exercise_4,
        "5": handle_exercise_5
    }
    input_message = ""
    for key in usecases:
        input_message += f" {key} - Zadanie {key} \n"
    input_message += " q - wyjscie z programu. \n"
    input_message += "Proszę wprowadzić numer zadania lub `q`: "

    while True:
        exercise_number: str = (
            input(input_message
                  )
            .strip()
            .lower()
        )
        if exercise_number in usecases:
            usecases[exercise_number]()
        elif exercise_number == "q":
            break
        else:
            print("Nieznany numer zadania!")


if __name__ == "__main__":
    main()
